/*
 * libmavis_null.c
 * (C)1999-2011 by Marc Huber <Marc.Huber@web.de>
 * All rights reserved.
 *
 * $Id: 51beea7ce0705ee72de12636664474814f9cfacb $
 *
 */

#define MAVIS_name "null"

#include <sys/types.h>
#include "misc/strops.h"

static const char rcsid[] __attribute__((used)) = "$Id: 51beea7ce0705ee72de12636664474814f9cfacb $";

#include "mavis.h"

#define HAVE_mavis_parse_in
static int mavis_parse_in(mavis_ctx * mcx, struct sym *sym)
{
    while (1) {
	switch (sym->code) {
	case S_script:
	    mavis_script_parse(mcx, NULL, sym);
	    continue;
	case S_eof:
	case S_closebra:
	    return MAVIS_CONF_OK;
	case S_action:
	    mavis_module_parse_action(mcx, sym);
	    continue;
	default:
	    parse_error_expect(sym, S_script, S_action, S_closebra, S_unknown);
	}
    }
}

#include "mavis_glue.c"
